/* MainWindow.c generated by valac 0.56.14, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2021 Daniel Foré (https://github.com/danrabbit)
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <handy.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define MAIN_WINDOW_RESULTS_CSS "\n" \
"        @define-color colorForeground %s;\n" \
"        @define-color colorBackground %s;\n" \
"\n" \
"        .results {\n" \
"            transition: all 250ms ease-in-out;\n" \
"        }\n" \
"    "
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;

struct _MainWindow {
	HdyWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	HdyWindowClass parent_class;
};

struct _MainWindowPrivate {
	GdkRGBA gdk_color;
	GtkEntry* bg_entry;
	GtkEntry* fg_entry;
	GtkLabel* results_label;
	GradeLabel* a_level;
	GradeLabel* aa_level;
	GradeLabel* aaa_level;
	gchar* prev_foreground_entry;
	gchar* prev_background_entry;
};

struct _Block2Data {
	int _ref_count_;
	MainWindow* self;
	GtkColorSelection* widget;
	GtkEntry* entry;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;
VALA_EXTERN GSettings* harvey_settings;

VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN GType grade_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GradeLabel, g_object_unref)
VALA_EXTERN MainWindow* main_window_new (GtkApplication* application);
VALA_EXTERN MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_on_entry_icon_press (MainWindow* self,
                                      GtkEntry* entry);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_);
static void ___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                                    gpointer self);
static void main_window_on_entry_changed (MainWindow* self);
static void main_window_style_results_pane (MainWindow* self,
                                     const gchar* fg_color,
                                     const gchar* bg_color);
static gdouble main_window_get_luminance (MainWindow* self,
                                   GdkRGBA* color);
VALA_EXTERN void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static gdouble main_window_sanitize_color (MainWindow* self,
                                    gdouble color);
static gboolean main_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN GradeLabel* grade_label_new (const gchar* level);
VALA_EXTERN GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
static void _main_window___lambda5_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEvent* event);
static void __main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEvent* event,
                                                    gpointer self);
static void _main_window___lambda6_ (MainWindow* self);
static void __main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda7_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEvent* event);
static void __main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEvent* event,
                                                    gpointer self);
static void _main_window___lambda8_ (MainWindow* self);
static void __main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void main_window_finalize (GObject * obj);
static GType main_window_get_type_once (void);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
#line 27 "../src/MainWindow.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 28 "../src/MainWindow.vala"
	self = (MainWindow*) g_object_new (object_type, "application", application, "height-request", 500, "icon-name", "com.github.danrabbit.harvey", "resizable", FALSE, "title", _ ("Harvey"), "width-request", 700, NULL);
#line 27 "../src/MainWindow.vala"
	return self;
#line 172 "MainWindow.c"
}

MainWindow*
main_window_new (GtkApplication* application)
{
#line 27 "../src/MainWindow.vala"
	return main_window_construct (TYPE_MAIN_WINDOW, application);
#line 180 "MainWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 140 "../src/MainWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 188 "MainWindow.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 140 "../src/MainWindow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 140 "../src/MainWindow.vala"
	return _data2_;
#line 198 "MainWindow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 140 "../src/MainWindow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 208 "MainWindow.c"
		MainWindow* self;
#line 140 "../src/MainWindow.vala"
		self = _data2_->self;
#line 140 "../src/MainWindow.vala"
		_g_object_unref0 (_data2_->entry);
#line 140 "../src/MainWindow.vala"
		_g_object_unref0 (self);
#line 140 "../src/MainWindow.vala"
		g_slice_free (Block2Data, _data2_);
#line 218 "MainWindow.c"
	}
}

static void
__lambda4_ (Block2Data* _data2_)
{
	MainWindow* self;
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	GtkColorSelection* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GdkRGBA _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
#line 150 "../src/MainWindow.vala"
	self = _data2_->self;
#line 151 "../src/MainWindow.vala"
	_tmp1_ = self->priv->fg_entry;
#line 151 "../src/MainWindow.vala"
	if (_data2_->entry == _tmp1_) {
#line 239 "MainWindow.c"
		const gchar* _tmp2_;
#line 151 "../src/MainWindow.vala"
		_tmp2_ = self->priv->prev_foreground_entry;
#line 151 "../src/MainWindow.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 245 "MainWindow.c"
	} else {
#line 151 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 249 "MainWindow.c"
	}
#line 151 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 253 "MainWindow.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 152 "../src/MainWindow.vala"
		_tmp3_ = gtk_entry_get_text (_data2_->entry);
#line 152 "../src/MainWindow.vala"
		_tmp4_ = _tmp3_;
#line 152 "../src/MainWindow.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 152 "../src/MainWindow.vala"
		_g_free0 (self->priv->prev_foreground_entry);
#line 152 "../src/MainWindow.vala"
		self->priv->prev_foreground_entry = _tmp5_;
#line 267 "MainWindow.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GtkEntry* _tmp7_;
#line 153 "../src/MainWindow.vala"
		_tmp7_ = self->priv->bg_entry;
#line 153 "../src/MainWindow.vala"
		if (_data2_->entry == _tmp7_) {
#line 275 "MainWindow.c"
			const gchar* _tmp8_;
#line 153 "../src/MainWindow.vala"
			_tmp8_ = self->priv->prev_background_entry;
#line 153 "../src/MainWindow.vala"
			_tmp6_ = _tmp8_ == NULL;
#line 281 "MainWindow.c"
		} else {
#line 153 "../src/MainWindow.vala"
			_tmp6_ = FALSE;
#line 285 "MainWindow.c"
		}
#line 153 "../src/MainWindow.vala"
		if (_tmp6_) {
#line 289 "MainWindow.c"
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 154 "../src/MainWindow.vala"
			_tmp9_ = gtk_entry_get_text (_data2_->entry);
#line 154 "../src/MainWindow.vala"
			_tmp10_ = _tmp9_;
#line 154 "../src/MainWindow.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 154 "../src/MainWindow.vala"
			_g_free0 (self->priv->prev_background_entry);
#line 154 "../src/MainWindow.vala"
			self->priv->prev_background_entry = _tmp11_;
#line 303 "MainWindow.c"
		}
	}
#line 157 "../src/MainWindow.vala"
	_tmp12_ = _data2_->widget;
#line 157 "../src/MainWindow.vala"
	gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
#line 157 "../src/MainWindow.vala"
	_tmp14_ = _tmp13_;
#line 157 "../src/MainWindow.vala"
	_tmp15_ = gdk_rgba_to_string (&_tmp14_);
#line 157 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 157 "../src/MainWindow.vala"
	gtk_entry_set_text (_data2_->entry, _tmp16_);
#line 157 "../src/MainWindow.vala"
	_g_free0 (_tmp16_);
#line 320 "MainWindow.c"
}

static void
___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                               gpointer self)
{
#line 150 "../src/MainWindow.vala"
	__lambda4_ (self);
#line 329 "MainWindow.c"
}

static void
main_window_on_entry_icon_press (MainWindow* self,
                                 GtkEntry* entry)
{
	Block2Data* _data2_;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkColorSelectionDialog* dialog = NULL;
	GtkColorSelectionDialog* _tmp3_;
	GtkColorSelectionDialog* _tmp4_;
	GtkColorSelectionDialog* _tmp5_;
	GtkColorSelectionDialog* _tmp6_;
	GtkColorSelection* _tmp7_;
	GtkColorSelection* _tmp8_;
	GdkRGBA _tmp9_;
	GtkColorSelection* _tmp10_;
	GtkColorSelectionDialog* _tmp11_;
	GtkColorSelectionDialog* _tmp23_;
#line 140 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/MainWindow.vala"
	g_return_if_fail (entry != NULL);
#line 140 "../src/MainWindow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 140 "../src/MainWindow.vala"
	_data2_->_ref_count_ = 1;
#line 140 "../src/MainWindow.vala"
	_data2_->self = g_object_ref (self);
#line 140 "../src/MainWindow.vala"
	_tmp0_ = _g_object_ref0 (entry);
#line 140 "../src/MainWindow.vala"
	_g_object_unref0 (_data2_->entry);
#line 140 "../src/MainWindow.vala"
	_data2_->entry = _tmp0_;
#line 141 "../src/MainWindow.vala"
	_tmp1_ = gtk_entry_get_text (_data2_->entry);
#line 141 "../src/MainWindow.vala"
	_tmp2_ = _tmp1_;
#line 141 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, _tmp2_);
#line 143 "../src/MainWindow.vala"
	_tmp3_ = (GtkColorSelectionDialog*) gtk_color_selection_dialog_new ("");
#line 143 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 143 "../src/MainWindow.vala"
	dialog = _tmp3_;
#line 144 "../src/MainWindow.vala"
	_tmp4_ = dialog;
#line 144 "../src/MainWindow.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp4_, FALSE);
#line 145 "../src/MainWindow.vala"
	_tmp5_ = dialog;
#line 145 "../src/MainWindow.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, (GtkWindow*) self);
#line 147 "../src/MainWindow.vala"
	_tmp6_ = dialog;
#line 147 "../src/MainWindow.vala"
	_tmp7_ = gtk_color_selection_dialog_get_color_selection (_tmp6_);
#line 147 "../src/MainWindow.vala"
	_data2_->widget = _tmp7_;
#line 148 "../src/MainWindow.vala"
	_tmp8_ = _data2_->widget;
#line 148 "../src/MainWindow.vala"
	_tmp9_ = self->priv->gdk_color;
#line 148 "../src/MainWindow.vala"
	gtk_color_selection_set_current_rgba (_tmp8_, &_tmp9_);
#line 150 "../src/MainWindow.vala"
	_tmp10_ = _data2_->widget;
#line 150 "../src/MainWindow.vala"
	g_signal_connect_data (_tmp10_, "color-changed", (GCallback) ___lambda4__gtk_color_selection_color_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 160 "../src/MainWindow.vala"
	_tmp11_ = dialog;
#line 160 "../src/MainWindow.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp11_) == ((gint) GTK_RESPONSE_OK)) {
#line 407 "MainWindow.c"
		GtkColorSelection* _tmp12_;
		GdkRGBA _tmp13_ = {0};
		GdkRGBA _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 161 "../src/MainWindow.vala"
		_tmp12_ = _data2_->widget;
#line 161 "../src/MainWindow.vala"
		gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
#line 161 "../src/MainWindow.vala"
		_tmp14_ = _tmp13_;
#line 161 "../src/MainWindow.vala"
		_tmp15_ = gdk_rgba_to_string (&_tmp14_);
#line 161 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 161 "../src/MainWindow.vala"
		gtk_entry_set_text (_data2_->entry, _tmp16_);
#line 161 "../src/MainWindow.vala"
		_g_free0 (_tmp16_);
#line 427 "MainWindow.c"
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp20_;
#line 163 "../src/MainWindow.vala"
		_tmp17_ = self->priv->prev_foreground_entry;
#line 163 "../src/MainWindow.vala"
		if (_tmp17_ != NULL) {
#line 435 "MainWindow.c"
			GtkEntry* _tmp18_;
			const gchar* _tmp19_;
#line 164 "../src/MainWindow.vala"
			_tmp18_ = self->priv->fg_entry;
#line 164 "../src/MainWindow.vala"
			_tmp19_ = self->priv->prev_foreground_entry;
#line 164 "../src/MainWindow.vala"
			gtk_entry_set_text (_tmp18_, _tmp19_);
#line 444 "MainWindow.c"
		}
#line 167 "../src/MainWindow.vala"
		_tmp20_ = self->priv->prev_background_entry;
#line 167 "../src/MainWindow.vala"
		if (_tmp20_ != NULL) {
#line 450 "MainWindow.c"
			GtkEntry* _tmp21_;
			const gchar* _tmp22_;
#line 168 "../src/MainWindow.vala"
			_tmp21_ = self->priv->bg_entry;
#line 168 "../src/MainWindow.vala"
			_tmp22_ = self->priv->prev_background_entry;
#line 168 "../src/MainWindow.vala"
			gtk_entry_set_text (_tmp21_, _tmp22_);
#line 459 "MainWindow.c"
		}
	}
#line 172 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_foreground_entry);
#line 172 "../src/MainWindow.vala"
	self->priv->prev_foreground_entry = NULL;
#line 173 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_background_entry);
#line 173 "../src/MainWindow.vala"
	self->priv->prev_background_entry = NULL;
#line 175 "../src/MainWindow.vala"
	_tmp23_ = dialog;
#line 175 "../src/MainWindow.vala"
	g_signal_emit_by_name ((GtkDialog*) _tmp23_, "close");
#line 140 "../src/MainWindow.vala"
	_g_object_unref0 (dialog);
#line 140 "../src/MainWindow.vala"
	block2_data_unref (_data2_);
#line 140 "../src/MainWindow.vala"
	_data2_ = NULL;
#line 480 "MainWindow.c"
}

static void
main_window_on_entry_changed (MainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 178 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/MainWindow.vala"
	_tmp1_ = self->priv->fg_entry;
#line 179 "../src/MainWindow.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 179 "../src/MainWindow.vala"
	_tmp3_ = _tmp2_;
#line 179 "../src/MainWindow.vala"
	_tmp4_ = strlen (_tmp3_);
#line 179 "../src/MainWindow.vala"
	_tmp5_ = _tmp4_;
#line 179 "../src/MainWindow.vala"
	if (_tmp5_ > 2) {
#line 506 "MainWindow.c"
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 179 "../src/MainWindow.vala"
		_tmp6_ = self->priv->bg_entry;
#line 179 "../src/MainWindow.vala"
		_tmp7_ = gtk_entry_get_text (_tmp6_);
#line 179 "../src/MainWindow.vala"
		_tmp8_ = _tmp7_;
#line 179 "../src/MainWindow.vala"
		_tmp9_ = strlen (_tmp8_);
#line 179 "../src/MainWindow.vala"
		_tmp10_ = _tmp9_;
#line 179 "../src/MainWindow.vala"
		_tmp0_ = _tmp10_ > 2;
#line 524 "MainWindow.c"
	} else {
#line 179 "../src/MainWindow.vala"
		_tmp0_ = FALSE;
#line 528 "MainWindow.c"
	}
#line 179 "../src/MainWindow.vala"
	if (_tmp0_) {
#line 532 "MainWindow.c"
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 180 "../src/MainWindow.vala"
		_tmp11_ = self->priv->fg_entry;
#line 180 "../src/MainWindow.vala"
		_tmp12_ = gtk_entry_get_text (_tmp11_);
#line 180 "../src/MainWindow.vala"
		_tmp13_ = _tmp12_;
#line 180 "../src/MainWindow.vala"
		_tmp14_ = self->priv->bg_entry;
#line 180 "../src/MainWindow.vala"
		_tmp15_ = gtk_entry_get_text (_tmp14_);
#line 180 "../src/MainWindow.vala"
		_tmp16_ = _tmp15_;
#line 180 "../src/MainWindow.vala"
		main_window_style_results_pane (self, _tmp13_, _tmp16_);
#line 553 "MainWindow.c"
	}
}

static void
main_window_style_results_pane (MainWindow* self,
                                const gchar* fg_color,
                                const gchar* bg_color)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GSettings* _tmp9_;
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GSettings* _tmp13_;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gdouble pango_fg_luminance = 0.0;
	GdkRGBA _tmp17_;
	gdouble pango_bg_luminance = 0.0;
	GdkRGBA _tmp18_;
	gdouble contrast_ratio = 0.0;
	GtkLabel* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
#line 184 "../src/MainWindow.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/MainWindow.vala"
	g_return_if_fail (fg_color != NULL);
#line 184 "../src/MainWindow.vala"
	g_return_if_fail (bg_color != NULL);
#line 185 "../src/MainWindow.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 185 "../src/MainWindow.vala"
	provider = _tmp0_;
#line 591 "MainWindow.c"
	{
		gchar* colored_css = NULL;
		gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
#line 187 "../src/MainWindow.vala"
		_tmp1_ = g_strdup_printf (MAIN_WINDOW_RESULTS_CSS, fg_color, bg_color);
#line 187 "../src/MainWindow.vala"
		colored_css = _tmp1_;
#line 188 "../src/MainWindow.vala"
		_tmp2_ = provider;
#line 188 "../src/MainWindow.vala"
		_tmp3_ = colored_css;
#line 188 "../src/MainWindow.vala"
		_tmp4_ = colored_css;
#line 188 "../src/MainWindow.vala"
		_tmp5_ = strlen (_tmp4_);
#line 188 "../src/MainWindow.vala"
		_tmp6_ = _tmp5_;
#line 188 "../src/MainWindow.vala"
		gtk_css_provider_load_from_data (_tmp2_, _tmp3_, (gssize) _tmp6_, &_inner_error0_);
#line 188 "../src/MainWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "../src/MainWindow.vala"
			_g_free0 (colored_css);
#line 622 "MainWindow.c"
			goto __catch0_g_error;
		}
#line 190 "../src/MainWindow.vala"
		_tmp7_ = gdk_screen_get_default ();
#line 190 "../src/MainWindow.vala"
		_tmp8_ = provider;
#line 190 "../src/MainWindow.vala"
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 186 "../src/MainWindow.vala"
		_g_free0 (colored_css);
#line 633 "MainWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 186 "../src/MainWindow.vala"
		g_clear_error (&_inner_error0_);
#line 192 "../src/MainWindow.vala"
		_g_object_unref0 (provider);
#line 192 "../src/MainWindow.vala"
		return;
#line 644 "MainWindow.c"
	}
	__finally0:
#line 186 "../src/MainWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 186 "../src/MainWindow.vala"
		_g_object_unref0 (provider);
#line 186 "../src/MainWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "../src/MainWindow.vala"
		g_clear_error (&_inner_error0_);
#line 186 "../src/MainWindow.vala"
		return;
#line 657 "MainWindow.c"
	}
#line 195 "../src/MainWindow.vala"
	_tmp9_ = harvey_settings;
#line 195 "../src/MainWindow.vala"
	_tmp10_ = self->priv->fg_entry;
#line 195 "../src/MainWindow.vala"
	_tmp11_ = gtk_entry_get_text (_tmp10_);
#line 195 "../src/MainWindow.vala"
	_tmp12_ = _tmp11_;
#line 195 "../src/MainWindow.vala"
	g_settings_set_string (_tmp9_, "fg-color", _tmp12_);
#line 196 "../src/MainWindow.vala"
	_tmp13_ = harvey_settings;
#line 196 "../src/MainWindow.vala"
	_tmp14_ = self->priv->bg_entry;
#line 196 "../src/MainWindow.vala"
	_tmp15_ = gtk_entry_get_text (_tmp14_);
#line 196 "../src/MainWindow.vala"
	_tmp16_ = _tmp15_;
#line 196 "../src/MainWindow.vala"
	g_settings_set_string (_tmp13_, "bg-color", _tmp16_);
#line 198 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, fg_color);
#line 199 "../src/MainWindow.vala"
	_tmp17_ = self->priv->gdk_color;
#line 199 "../src/MainWindow.vala"
	pango_fg_luminance = main_window_get_luminance (self, &_tmp17_);
#line 201 "../src/MainWindow.vala"
	gdk_rgba_parse (&self->priv->gdk_color, bg_color);
#line 202 "../src/MainWindow.vala"
	_tmp18_ = self->priv->gdk_color;
#line 202 "../src/MainWindow.vala"
	pango_bg_luminance = main_window_get_luminance (self, &_tmp18_);
#line 206 "../src/MainWindow.vala"
	if (pango_bg_luminance > pango_fg_luminance) {
#line 207 "../src/MainWindow.vala"
		contrast_ratio = (pango_bg_luminance + 0.05) / (pango_fg_luminance + 0.05);
#line 695 "MainWindow.c"
	} else {
#line 209 "../src/MainWindow.vala"
		contrast_ratio = (pango_fg_luminance + 0.05) / (pango_bg_luminance + 0.05);
#line 699 "MainWindow.c"
	}
#line 212 "../src/MainWindow.vala"
	_tmp19_ = self->priv->results_label;
#line 212 "../src/MainWindow.vala"
	_tmp20_ = g_strdup_printf ("%.1f:1", contrast_ratio);
#line 212 "../src/MainWindow.vala"
	_tmp21_ = _tmp20_;
#line 212 "../src/MainWindow.vala"
	gtk_label_set_label (_tmp19_, _tmp21_);
#line 212 "../src/MainWindow.vala"
	_g_free0 (_tmp21_);
#line 214 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 3)) {
#line 713 "MainWindow.c"
		GradeLabel* _tmp22_;
#line 215 "../src/MainWindow.vala"
		_tmp22_ = self->priv->a_level;
#line 215 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp22_, TRUE);
#line 719 "MainWindow.c"
	} else {
		GradeLabel* _tmp23_;
#line 217 "../src/MainWindow.vala"
		_tmp23_ = self->priv->a_level;
#line 217 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp23_, FALSE);
#line 726 "MainWindow.c"
	}
#line 220 "../src/MainWindow.vala"
	if (contrast_ratio >= 4.5) {
#line 730 "MainWindow.c"
		GradeLabel* _tmp24_;
#line 221 "../src/MainWindow.vala"
		_tmp24_ = self->priv->aa_level;
#line 221 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp24_, TRUE);
#line 736 "MainWindow.c"
	} else {
		GradeLabel* _tmp25_;
#line 223 "../src/MainWindow.vala"
		_tmp25_ = self->priv->aa_level;
#line 223 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp25_, FALSE);
#line 743 "MainWindow.c"
	}
#line 226 "../src/MainWindow.vala"
	if (contrast_ratio >= ((gdouble) 7)) {
#line 747 "MainWindow.c"
		GradeLabel* _tmp26_;
#line 227 "../src/MainWindow.vala"
		_tmp26_ = self->priv->aaa_level;
#line 227 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp26_, TRUE);
#line 753 "MainWindow.c"
	} else {
		GradeLabel* _tmp27_;
#line 229 "../src/MainWindow.vala"
		_tmp27_ = self->priv->aaa_level;
#line 229 "../src/MainWindow.vala"
		grade_label_set_pass (_tmp27_, FALSE);
#line 760 "MainWindow.c"
	}
#line 184 "../src/MainWindow.vala"
	_g_object_unref0 (provider);
#line 764 "MainWindow.c"
}

static gdouble
main_window_get_luminance (MainWindow* self,
                           GdkRGBA* color)
{
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	gdouble result;
#line 234 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 234 "../src/MainWindow.vala"
	g_return_val_if_fail (color != NULL, 0.0);
#line 235 "../src/MainWindow.vala"
	_tmp0_ = *color;
#line 235 "../src/MainWindow.vala"
	red = main_window_sanitize_color (self, _tmp0_.red) * 0.2126;
#line 236 "../src/MainWindow.vala"
	_tmp1_ = *color;
#line 236 "../src/MainWindow.vala"
	green = main_window_sanitize_color (self, _tmp1_.green) * 0.7152;
#line 237 "../src/MainWindow.vala"
	_tmp2_ = *color;
#line 237 "../src/MainWindow.vala"
	blue = main_window_sanitize_color (self, _tmp2_.blue) * 0.0722;
#line 239 "../src/MainWindow.vala"
	result = (red + green) + blue;
#line 239 "../src/MainWindow.vala"
	return result;
#line 798 "MainWindow.c"
}

static gdouble
main_window_sanitize_color (MainWindow* self,
                            gdouble color)
{
	gdouble result;
#line 242 "../src/MainWindow.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 243 "../src/MainWindow.vala"
	if (color <= 0.03928) {
#line 244 "../src/MainWindow.vala"
		color = color / 12.92;
#line 812 "MainWindow.c"
	} else {
#line 246 "../src/MainWindow.vala"
		color = pow ((color + 0.055) / 1.055, 2.4);
#line 816 "MainWindow.c"
	}
#line 248 "../src/MainWindow.vala"
	result = color;
#line 248 "../src/MainWindow.vala"
	return result;
#line 822 "MainWindow.c"
}

static gboolean
main_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	MainWindow * self;
	gint root_x = 0;
	gint root_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gboolean result;
#line 251 "../src/MainWindow.vala"
	self = (MainWindow*) base;
#line 251 "../src/MainWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 253 "../src/MainWindow.vala"
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
#line 253 "../src/MainWindow.vala"
	root_x = _tmp0_;
#line 253 "../src/MainWindow.vala"
	root_y = _tmp1_;
#line 254 "../src/MainWindow.vala"
	_tmp2_ = harvey_settings;
#line 254 "../src/MainWindow.vala"
	g_settings_set_int (_tmp2_, "window-x", root_x);
#line 255 "../src/MainWindow.vala"
	_tmp3_ = harvey_settings;
#line 255 "../src/MainWindow.vala"
	g_settings_set_int (_tmp3_, "window-y", root_y);
#line 257 "../src/MainWindow.vala"
	result = GTK_WIDGET_CLASS (main_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_window_get_type (), HdyWindow), event);
#line 257 "../src/MainWindow.vala"
	return result;
#line 859 "MainWindow.c"
}

static void
_main_window___lambda5_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEvent* event)
{
#line 117 "../src/MainWindow.vala"
	g_return_if_fail (event != NULL);
#line 118 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 871 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 119 "../src/MainWindow.vala"
		_tmp0_ = self->priv->fg_entry;
#line 119 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_);
#line 877 "MainWindow.c"
	}
}

static void
__main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEvent* event,
                                               gpointer self)
{
#line 117 "../src/MainWindow.vala"
	_main_window___lambda5_ ((MainWindow*) self, icon_pos, event);
#line 889 "MainWindow.c"
}

static void
_main_window___lambda6_ (MainWindow* self)
{
#line 124 "../src/MainWindow.vala"
	main_window_on_entry_changed (self);
#line 897 "MainWindow.c"
}

static void
__main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 123 "../src/MainWindow.vala"
	_main_window___lambda6_ ((MainWindow*) self);
#line 906 "MainWindow.c"
}

static void
_main_window___lambda7_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEvent* event)
{
#line 127 "../src/MainWindow.vala"
	g_return_if_fail (event != NULL);
#line 128 "../src/MainWindow.vala"
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
#line 918 "MainWindow.c"
		GtkEntry* _tmp0_;
#line 129 "../src/MainWindow.vala"
		_tmp0_ = self->priv->bg_entry;
#line 129 "../src/MainWindow.vala"
		main_window_on_entry_icon_press (self, _tmp0_);
#line 924 "MainWindow.c"
	}
}

static void
__main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEvent* event,
                                               gpointer self)
{
#line 127 "../src/MainWindow.vala"
	_main_window___lambda7_ ((MainWindow*) self, icon_pos, event);
#line 936 "MainWindow.c"
}

static void
_main_window___lambda8_ (MainWindow* self)
{
#line 134 "../src/MainWindow.vala"
	main_window_on_entry_changed (self);
#line 944 "MainWindow.c"
}

static void
__main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
#line 133 "../src/MainWindow.vala"
	_main_window___lambda8_ ((MainWindow*) self);
#line 953 "MainWindow.c"
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GtkLabel* fg_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* bg_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GSettings* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* input_grid = NULL;
	GtkGrid* _tmp23_ = NULL;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkEntry* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkEntry* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GradeLabel* _tmp39_;
	GradeLabel* _tmp40_;
	GradeLabel* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GradeLabel* _tmp44_;
	GradeLabel* _tmp45_;
	GradeLabel* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GradeLabel* _tmp49_;
	GradeLabel* _tmp50_;
	GradeLabel* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	GtkGrid* results_grid = NULL;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkGrid* _tmp58_;
	GtkLabel* _tmp59_;
	GtkGrid* _tmp60_;
	GradeLabel* _tmp61_;
	GtkGrid* _tmp62_;
	GradeLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GradeLabel* _tmp65_;
	HdyHeaderBar* input_header = NULL;
	gchar* _tmp66_;
	HdyHeaderBar* _tmp67_ = NULL;
	GtkStyleContext* input_header_context = NULL;
	HdyHeaderBar* _tmp68_;
	GtkStyleContext* _tmp69_;
	GtkStyleContext* _tmp70_;
	GtkStyleContext* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkStyleContext* _tmp73_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	HdyHeaderBar* _tmp76_;
	GtkGrid* _tmp77_;
	GtkGrid* _tmp78_;
	GtkGrid* _tmp79_;
	GtkGrid* _tmp80_;
	HdyWindowHandle* window_handle = NULL;
	HdyWindowHandle* _tmp81_;
	HdyWindowHandle* _tmp82_;
	GtkGrid* _tmp83_;
	HdyWindowHandle* _tmp84_;
	GtkEntry* _tmp85_;
	GtkEntry* _tmp86_;
	GtkEntry* _tmp87_;
	GtkEntry* _tmp88_;
	GtkEntry* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	GtkEntry* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
#line 38 "../src/MainWindow.vala"
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
#line 38 "../src/MainWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 39 "../src/MainWindow.vala"
	hdy_init ();
#line 41 "../src/MainWindow.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Foreground Color"));
#line 41 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/MainWindow.vala"
	fg_label = _tmp0_;
#line 42 "../src/MainWindow.vala"
	_tmp1_ = fg_label;
#line 42 "../src/MainWindow.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
#line 42 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp2_, "h4");
#line 43 "../src/MainWindow.vala"
	_tmp3_ = fg_label;
#line 43 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
#line 45 "../src/MainWindow.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Background Color"));
#line 45 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 45 "../src/MainWindow.vala"
	bg_label = _tmp4_;
#line 46 "../src/MainWindow.vala"
	_tmp5_ = bg_label;
#line 46 "../src/MainWindow.vala"
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
#line 46 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp6_, "h4");
#line 47 "../src/MainWindow.vala"
	_tmp7_ = bg_label;
#line 47 "../src/MainWindow.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 12);
#line 48 "../src/MainWindow.vala"
	_tmp8_ = bg_label;
#line 48 "../src/MainWindow.vala"
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
#line 50 "../src/MainWindow.vala"
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
#line 50 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp9_);
#line 50 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 50 "../src/MainWindow.vala"
	self->priv->fg_entry = _tmp9_;
#line 51 "../src/MainWindow.vala"
	_tmp10_ = self->priv->fg_entry;
#line 51 "../src/MainWindow.vala"
	_tmp11_ = harvey_settings;
#line 51 "../src/MainWindow.vala"
	_tmp12_ = g_settings_get_string (_tmp11_, "fg-color");
#line 51 "../src/MainWindow.vala"
	_tmp13_ = _tmp12_;
#line 51 "../src/MainWindow.vala"
	gtk_entry_set_text (_tmp10_, _tmp13_);
#line 51 "../src/MainWindow.vala"
	_g_free0 (_tmp13_);
#line 52 "../src/MainWindow.vala"
	_tmp14_ = self->priv->fg_entry;
#line 52 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp14_, "#333");
#line 53 "../src/MainWindow.vala"
	_tmp15_ = self->priv->fg_entry;
#line 53 "../src/MainWindow.vala"
	gtk_entry_set_icon_from_icon_name (_tmp15_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
#line 55 "../src/MainWindow.vala"
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
#line 55 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp16_);
#line 55 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 55 "../src/MainWindow.vala"
	self->priv->bg_entry = _tmp16_;
#line 56 "../src/MainWindow.vala"
	_tmp17_ = self->priv->bg_entry;
#line 56 "../src/MainWindow.vala"
	_tmp18_ = harvey_settings;
#line 56 "../src/MainWindow.vala"
	_tmp19_ = g_settings_get_string (_tmp18_, "bg-color");
#line 56 "../src/MainWindow.vala"
	_tmp20_ = _tmp19_;
#line 56 "../src/MainWindow.vala"
	gtk_entry_set_text (_tmp17_, _tmp20_);
#line 56 "../src/MainWindow.vala"
	_g_free0 (_tmp20_);
#line 57 "../src/MainWindow.vala"
	_tmp21_ = self->priv->bg_entry;
#line 57 "../src/MainWindow.vala"
	gtk_entry_set_placeholder_text (_tmp21_, "rgb (110, 200, 230)");
#line 58 "../src/MainWindow.vala"
	_tmp22_ = self->priv->bg_entry;
#line 58 "../src/MainWindow.vala"
	gtk_entry_set_icon_from_icon_name (_tmp22_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
#line 60 "../src/MainWindow.vala"
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
#line 60 "../src/MainWindow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_VERTICAL);
#line 60 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp23_, "margin", 12, NULL);
#line 60 "../src/MainWindow.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp23_, TRUE);
#line 60 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp23_);
#line 60 "../src/MainWindow.vala"
	input_grid = _tmp23_;
#line 65 "../src/MainWindow.vala"
	_tmp24_ = input_grid;
#line 65 "../src/MainWindow.vala"
	_tmp25_ = fg_label;
#line 65 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 66 "../src/MainWindow.vala"
	_tmp26_ = input_grid;
#line 66 "../src/MainWindow.vala"
	_tmp27_ = self->priv->fg_entry;
#line 66 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 67 "../src/MainWindow.vala"
	_tmp28_ = input_grid;
#line 67 "../src/MainWindow.vala"
	_tmp29_ = bg_label;
#line 67 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 68 "../src/MainWindow.vala"
	_tmp30_ = input_grid;
#line 68 "../src/MainWindow.vala"
	_tmp31_ = self->priv->bg_entry;
#line 68 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 70 "../src/MainWindow.vala"
	_tmp32_ = (GtkLabel*) gtk_label_new ("12:1");
#line 70 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp32_);
#line 70 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 70 "../src/MainWindow.vala"
	self->priv->results_label = _tmp32_;
#line 71 "../src/MainWindow.vala"
	_tmp33_ = self->priv->results_label;
#line 71 "../src/MainWindow.vala"
	g_object_set ((GtkWidget*) _tmp33_, "expand", TRUE, NULL);
#line 72 "../src/MainWindow.vala"
	_tmp34_ = self->priv->results_label;
#line 72 "../src/MainWindow.vala"
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 72 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp35_, "h1");
#line 73 "../src/MainWindow.vala"
	_tmp36_ = self->priv->results_label;
#line 73 "../src/MainWindow.vala"
	gtk_label_set_selectable (_tmp36_, TRUE);
#line 74 "../src/MainWindow.vala"
	_tmp37_ = self->priv->results_label;
#line 74 "../src/MainWindow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 75 "../src/MainWindow.vala"
	_tmp38_ = self->priv->results_label;
#line 75 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_CENTER);
#line 77 "../src/MainWindow.vala"
	_tmp39_ = grade_label_new ("WCAG A");
#line 77 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp39_);
#line 77 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 77 "../src/MainWindow.vala"
	self->priv->a_level = _tmp39_;
#line 78 "../src/MainWindow.vala"
	_tmp40_ = self->priv->a_level;
#line 78 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp40_, GTK_ALIGN_CENTER);
#line 79 "../src/MainWindow.vala"
	_tmp41_ = self->priv->a_level;
#line 79 "../src/MainWindow.vala"
	_tmp42_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("3:1"), _ ("The minimum level recommended by ISO-9241-3 and ANSI-HFES-100-1988 for" \
" standard text and vision"));
#line 79 "../src/MainWindow.vala"
	_tmp43_ = _tmp42_;
#line 79 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp41_, _tmp43_);
#line 79 "../src/MainWindow.vala"
	_g_free0 (_tmp43_);
#line 81 "../src/MainWindow.vala"
	_tmp44_ = grade_label_new ("WCAG AA");
#line 81 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp44_);
#line 81 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 81 "../src/MainWindow.vala"
	self->priv->aa_level = _tmp44_;
#line 82 "../src/MainWindow.vala"
	_tmp45_ = self->priv->aa_level;
#line 82 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
#line 83 "../src/MainWindow.vala"
	_tmp46_ = self->priv->aa_level;
#line 83 "../src/MainWindow.vala"
	_tmp47_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("4.5:1"), _ ("Compensates for the loss in contrast that results from moderately low " \
"visual acuity, color deficiencies, or aging."));
#line 83 "../src/MainWindow.vala"
	_tmp48_ = _tmp47_;
#line 83 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp46_, _tmp48_);
#line 83 "../src/MainWindow.vala"
	_g_free0 (_tmp48_);
#line 85 "../src/MainWindow.vala"
	_tmp49_ = grade_label_new ("WCAG AAA");
#line 85 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp49_);
#line 85 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 85 "../src/MainWindow.vala"
	self->priv->aaa_level = _tmp49_;
#line 86 "../src/MainWindow.vala"
	_tmp50_ = self->priv->aaa_level;
#line 86 "../src/MainWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
#line 87 "../src/MainWindow.vala"
	_tmp51_ = self->priv->aaa_level;
#line 87 "../src/MainWindow.vala"
	_tmp52_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("7:1"), _ ("Compensates for the loss in contrast sensitivity usually experienced b" \
"y users with about 20/80 vision. People with more than this degree of " \
"vision loss usually use assistive technologies."));
#line 87 "../src/MainWindow.vala"
	_tmp53_ = _tmp52_;
#line 87 "../src/MainWindow.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp51_, _tmp53_);
#line 87 "../src/MainWindow.vala"
	_g_free0 (_tmp53_);
#line 89 "../src/MainWindow.vala"
	_tmp54_ = (GtkGrid*) gtk_grid_new ();
#line 89 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp54_);
#line 89 "../src/MainWindow.vala"
	results_grid = _tmp54_;
#line 90 "../src/MainWindow.vala"
	_tmp55_ = results_grid;
#line 90 "../src/MainWindow.vala"
	gtk_grid_set_row_spacing (_tmp55_, 12);
#line 91 "../src/MainWindow.vala"
	_tmp56_ = results_grid;
#line 91 "../src/MainWindow.vala"
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
#line 91 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp57_, "results");
#line 92 "../src/MainWindow.vala"
	_tmp58_ = results_grid;
#line 92 "../src/MainWindow.vala"
	_tmp59_ = self->priv->results_label;
#line 92 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 0, 0, 3, 1);
#line 93 "../src/MainWindow.vala"
	_tmp60_ = results_grid;
#line 93 "../src/MainWindow.vala"
	_tmp61_ = self->priv->a_level;
#line 93 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 1, 1, 1);
#line 94 "../src/MainWindow.vala"
	_tmp62_ = results_grid;
#line 94 "../src/MainWindow.vala"
	_tmp63_ = self->priv->aa_level;
#line 94 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 1, 1, 1, 1);
#line 95 "../src/MainWindow.vala"
	_tmp64_ = results_grid;
#line 95 "../src/MainWindow.vala"
	_tmp65_ = self->priv->aaa_level;
#line 95 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 2, 1, 1, 1);
#line 97 "../src/MainWindow.vala"
	_tmp66_ = g_strdup ("close:");
#line 97 "../src/MainWindow.vala"
	_tmp67_ = (HdyHeaderBar*) hdy_header_bar_new ();
#line 97 "../src/MainWindow.vala"
	hdy_header_bar_set_decoration_layout (_tmp67_, _tmp66_);
#line 97 "../src/MainWindow.vala"
	_g_free0 (_tmp66_);
#line 97 "../src/MainWindow.vala"
	hdy_header_bar_set_show_close_button (_tmp67_, TRUE);
#line 97 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp67_);
#line 97 "../src/MainWindow.vala"
	input_header = _tmp67_;
#line 102 "../src/MainWindow.vala"
	_tmp68_ = input_header;
#line 102 "../src/MainWindow.vala"
	_tmp69_ = gtk_widget_get_style_context ((GtkWidget*) _tmp68_);
#line 102 "../src/MainWindow.vala"
	_tmp70_ = _g_object_ref0 (_tmp69_);
#line 102 "../src/MainWindow.vala"
	input_header_context = _tmp70_;
#line 103 "../src/MainWindow.vala"
	_tmp71_ = input_header_context;
#line 103 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp71_, "input-header");
#line 104 "../src/MainWindow.vala"
	_tmp72_ = input_header_context;
#line 104 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp72_, "default-decoration");
#line 105 "../src/MainWindow.vala"
	_tmp73_ = input_header_context;
#line 105 "../src/MainWindow.vala"
	gtk_style_context_add_class (_tmp73_, GTK_STYLE_CLASS_FLAT);
#line 107 "../src/MainWindow.vala"
	_tmp74_ = (GtkGrid*) gtk_grid_new ();
#line 107 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp74_);
#line 107 "../src/MainWindow.vala"
	grid = _tmp74_;
#line 108 "../src/MainWindow.vala"
	_tmp75_ = grid;
#line 108 "../src/MainWindow.vala"
	_tmp76_ = input_header;
#line 108 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 0, 0, 1, 1);
#line 109 "../src/MainWindow.vala"
	_tmp77_ = grid;
#line 109 "../src/MainWindow.vala"
	_tmp78_ = input_grid;
#line 109 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 1, 1, 1);
#line 110 "../src/MainWindow.vala"
	_tmp79_ = grid;
#line 110 "../src/MainWindow.vala"
	_tmp80_ = results_grid;
#line 110 "../src/MainWindow.vala"
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 0, 1, 2);
#line 112 "../src/MainWindow.vala"
	_tmp81_ = (HdyWindowHandle*) hdy_window_handle_new ();
#line 112 "../src/MainWindow.vala"
	g_object_ref_sink (_tmp81_);
#line 112 "../src/MainWindow.vala"
	window_handle = _tmp81_;
#line 113 "../src/MainWindow.vala"
	_tmp82_ = window_handle;
#line 113 "../src/MainWindow.vala"
	_tmp83_ = grid;
#line 113 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp82_, (GtkWidget*) _tmp83_);
#line 115 "../src/MainWindow.vala"
	_tmp84_ = window_handle;
#line 115 "../src/MainWindow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp84_);
#line 117 "../src/MainWindow.vala"
	_tmp85_ = self->priv->fg_entry;
#line 117 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp85_, "icon-press", (GCallback) __main_window___lambda5__gtk_entry_icon_press, self, 0);
#line 123 "../src/MainWindow.vala"
	_tmp86_ = self->priv->fg_entry;
#line 123 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp86_, "changed", (GCallback) __main_window___lambda6__gtk_editable_changed, self, 0);
#line 127 "../src/MainWindow.vala"
	_tmp87_ = self->priv->bg_entry;
#line 127 "../src/MainWindow.vala"
	g_signal_connect_object (_tmp87_, "icon-press", (GCallback) __main_window___lambda7__gtk_entry_icon_press, self, 0);
#line 133 "../src/MainWindow.vala"
	_tmp88_ = self->priv->bg_entry;
#line 133 "../src/MainWindow.vala"
	g_signal_connect_object ((GtkEditable*) _tmp88_, "changed", (GCallback) __main_window___lambda8__gtk_editable_changed, self, 0);
#line 137 "../src/MainWindow.vala"
	_tmp89_ = self->priv->fg_entry;
#line 137 "../src/MainWindow.vala"
	_tmp90_ = gtk_entry_get_text (_tmp89_);
#line 137 "../src/MainWindow.vala"
	_tmp91_ = _tmp90_;
#line 137 "../src/MainWindow.vala"
	_tmp92_ = self->priv->bg_entry;
#line 137 "../src/MainWindow.vala"
	_tmp93_ = gtk_entry_get_text (_tmp92_);
#line 137 "../src/MainWindow.vala"
	_tmp94_ = _tmp93_;
#line 137 "../src/MainWindow.vala"
	main_window_style_results_pane (self, _tmp91_, _tmp94_);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (window_handle);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (grid);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (input_header_context);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (input_header);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (results_grid);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (input_grid);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (bg_label);
#line 38 "../src/MainWindow.vala"
	_g_object_unref0 (fg_label);
#line 38 "../src/MainWindow.vala"
	return obj;
#line 1461 "MainWindow.c"
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
#line 6 "../src/MainWindow.vala"
	main_window_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/MainWindow.vala"
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
#line 6 "../src/MainWindow.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) main_window_real_configure_event;
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
#line 1478 "MainWindow.c"
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
#line 6 "../src/MainWindow.vala"
	self->priv = main_window_get_instance_private (self);
#line 24 "../src/MainWindow.vala"
	self->priv->prev_foreground_entry = NULL;
#line 25 "../src/MainWindow.vala"
	self->priv->prev_background_entry = NULL;
#line 1491 "MainWindow.c"
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
#line 6 "../src/MainWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
#line 17 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->bg_entry);
#line 18 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->fg_entry);
#line 19 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->results_label);
#line 20 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->a_level);
#line 21 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aa_level);
#line 22 "../src/MainWindow.vala"
	_g_object_unref0 (self->priv->aaa_level);
#line 24 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_foreground_entry);
#line 25 "../src/MainWindow.vala"
	_g_free0 (self->priv->prev_background_entry);
#line 6 "../src/MainWindow.vala"
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
#line 1518 "MainWindow.c"
}

static GType
main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
	GType main_window_type_id;
	main_window_type_id = g_type_register_static (hdy_window_get_type (), "MainWindow", &g_define_type_info, 0);
	MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
	return main_window_type_id;
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__once = 0;
	if (g_once_init_enter (&main_window_type_id__once)) {
		GType main_window_type_id;
		main_window_type_id = main_window_get_type_once ();
		g_once_init_leave (&main_window_type_id__once, main_window_type_id);
	}
	return main_window_type_id__once;
}

